if(!isObject(ClientGameModeStorerSO))
{
	new ScriptObject(ClientGameModeStorerSO){modeCount=-1;};
}

if(!isObject(TeamEditGui))
	exec("./MinigameGUI_TeamEdit.gui");

function GuiSwatchCtrl::extend(%this,%amt,%yext)
{
	%pos = %this.getPosition();
	%x = getWord(%pos,0);
	%y = getWord(%pos,1);
	if(%obj.tdmClient_y $= "")
		%obj.tdmClient_y = %y;
	%ext = %this.getExtent();
	%w = getWord(%ext,0);
	%h = getWord(%ext,1);
	%this.resize(%x,%y,%w,%h+%amt);
	if(%this.tdmClient_h <= 0)
		%this.tdmClient_h = %h;
	%this.tdmClient_extH = %this.tdmClient_extH+%amt;
	
	for(%i=0;%i<%this.getCount();%i++)
	{
		%obj = %this.getObject(%i);
		%pos = %obj.getPosition();
		%x = getWord(%pos,0);
		%y = getWord(%pos,1);
		if(%obj.tdmClient_y $= "")
			%obj.tdmClient_y = %y;
		%ext = %obj.getExtent();
		%w = getWord(%ext,0);
		%h = getWord(%ext,1);
		if(%y > %yext)
		{
			%obj.resize(%x,%y+%amt,%w,%h);
			%obj.yoffset = (%y+%amt) - %obj.tdmClient_y;
		}
	}
}

function CMG_GetTDMGeneralCatID(%cat)
{
	return $SpaceMods::Client::TeamDM::GeneralCat[$SpaceMods::Client::TeamDM::GeneralCatID[%cat]];
}

function CreateMinigameGUI::makeGeneralTabSpace(%this,%obj,%amt,%yext)
{
	if(%obj.tdmClient_h $= "")
	{
		%ext = %obj.getExtent();
		%obj.tdmClient_w = getWord(%ext,0);
		%obj.tdmClient_h = getWord(%ext,1);
	}
	%obj.extend(%amt,%yext);
	for(%i=%id+1;%i<4;%i++)
	{
		%mobj = $SpaceMods::Client::TeamDM::GeneralCat[%i];
		%pos = %mobj.getPosition();
		%x = getWord(%pos,0);
		%y = getWord(%pos,1);
		%ext = %mobj.getExtent();
		%w = getWord(%ext,0);
		%h = getWord(%ext,1);
		%mobj.resize(%x,%y+%amt,%w,%h);
	}
	%pos = CMG_ScrollBox.getPosition();
	%x = getWord(%pos,0);
	%y = getWord(%pos,1);
	%ext = CMG_ScrollBox.getExtent();
	%w = getWord(%ext,0);
	%h = getWord(%ext,1);
	if(CMG_ScrollBox.tdmClient_h <= 0)
	{
		CMG_ScrollBox.tdmClient_x = %x;
		CMG_ScrollBox.tdmClient_y = %y;
		CMG_ScrollBox.tdmClient_w = %w;
		CMG_ScrollBox.tdmClient_h = %h;
	}
	CMG_ScrollBox.tdmClient_extH = %h + %amt;
	CMG_ScrollBox.resize(%x,%y,%w,%h+%amt);
}

function addGameModeGUIControls()
{
	new SimSet(CreateMinigameFrame_All);
	for(%i=0;%i<CMG_Window.getCount();%i++)
	{
		%obj = CMG_Window.getObject(%i);
		%pos = %obj.getPosition();
		%x = getWord(%pos,0);
		%y = getWord(%pos,1);
		if(%y > 10)
		{
			CreateMiniGameFrame_All.add(%obj);
			%obj.originalPos = %obj.getPosition();
			continue;
		}
	}
	
	new SimSet(CreateMiniGameFrame_General){};
	for(%i=0;%i<CMG_ScrollBox.getCount();%i++)
	{
		%obj = CMG_ScrollBox.getObject(%i);
		%ext = %obj.getExtent();
		%obj.tdmClient_w = getWord(%ext,0);
		%obj.tdmClient_h = getWord(%ext,1);
		%obj.tdmClient_extH = getWord(%ext,1);
		$SpaceMods::Client::TeamDM::GeneralCat[%i] = %obj;
		$SpaceMods::Client::TeamDM::GeneralCatID[%obj.getObject(1).getValue()] = %i;
		CreateMiniGameFrame_General.add(%obj);
	}
	
	%ext = CMG_Window.getExtent();
	CMG_Window.tdmClient_w = getWord(%ext,0);
	CMG_Window.tdmClient_h = getWord(%ext,1);
	new GUISwatchCtrl(CreateMiniGameFrame_TabsList)
	{
		profile = GuiDefaultProfile;
		horizSizing = right;
		vertSizing = bottom;
		position = "4 28";
		extent = "526 35";
		minExtent = "8 2";
		visible = 1;
		variable = "";
		command = "";
		altCommand = "";
		accelerator = "";
		color = "0 0 0 0";
		new GUISwatchCtrl()
		{
			profile = GuiDefaultProfile;
			horizSizing = right;
			vertSizing = bottom;
			position = "0 33";
			extent = "526 2";
			minExtent = "8 2";
			visible = 1;
			variable = "";
			command = "";
			altCommand = "";
			accelerator = "";
			color = "0 0 0 255";
		};
		new GuiBitmapButtonCtrl(CreateMinigameTab_GeneralButton)
		{
			profile = "BlockButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 8";
			extent = "99 25";
			minExtent = "8 2";
			visible = "1";
			command = "CreateMiniGameGUI.clickGeneralTab();";
			text = "General";
			groupNum = "-4";
			buttonType = "RadioButton";
			bitmap = "base/client/ui/tab1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 255 255 255";
		};
		new GuiBitmapButtonCtrl(CreateMinigameTab_TeamsButton)
		{
			profile = "BlockButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "100 8";
			extent = "99 25";
			minExtent = "8 2";
			visible = "1";
			command = "CreateMiniGameGUI.clickTeamsTab();";
			text = "Teams";
			groupNum = "-4";
			buttonType = "RadioButton";
			bitmap = "base/client/ui/tab1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 255 255 255";
		};
		new GuiBitmapButtonCtrl(CreateMinigameTab_RulesButton)
		{
			profile = "BlockButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "200 8";
			extent = "99 25";
			minExtent = "8 2";
			visible = "1";
			command = "CreateMiniGameGUI.clickRulesTab();";
			text = "Rules";
			groupNum = "-1";
			buttonType = "RadioButton";
			bitmap = "base/client/ui/tab1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 255 255 255";
		};
	};
	
	%tab = CMG_GetTDMGeneralCatID("Gameplay");
	new GuiPopUpMenuCtrl(CMG_SelectGamemode)
	{
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "100 123";
		extent = "133 22";
		minExtent = "8 2";
		visible = "1";
		maxLength = "255";
		maxPopupHeight = "200";
	};
	new GuiMLTextCtrl(CMG_SelectGamemodeText)
	{
		profile = "GuiMLTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "34 127";
		extent = "101 14";
		minExtent = "8 2";
		visible = "1";
		lineSpacing = "2";
		allowColorChars = "0";
		maxChars = "-1";
		text = "Gamemode:";
		maxBitmapHeight = "-1";
		selectable = "1";
	};
	CreateMinigameGUI.makeGeneralTabSpace(%tab,28,120);
	%tab.add(CMG_SelectGameMode);
	%tab.add(CMG_SelectGameModeText);
	
	%tab = CMG_GetTDMGeneralCatID("Gameplay");
	new GuiCheckboxCtrl(CMG_HidePlayerNames)
	{
		position = "33 331";
		extent = "140 18";
		text = "Hide Player Names";
		variable = "$Minigame::TDMHideNames";
		visible = 1;
	};CMG_Window.add(CMG_HidePlayerNames);
	CreateMinigameGUI.makeGeneralTabSpace(%tab,20,330);
	%tab.add(CMG_HidePlayerNames);
	
	%tab = CMG_GetTDMGeneralCatID("Scoring");
	new GuiTextEditCtrl(CMG_PointsTeamKill) 
	{
		profile = "GuiTextEditProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "118 133";
		extent = "36 18";
		minExtent = "8 2";
		visible = "1";
		maxLength = "255";
		historySize = "0";
		password = "0";
		tabComplete = "0";
		variable = "$Minigame::Points::TeamKill";
		command = "";
		sinkAllKeyEvents = "0";
		helpTag = "0";
	};
	new GuiMLTextCtrl(CMG_PointsTeamKillText) 
	{
		profile = "GuiMLTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "16 133";
		extent = "94 14";
		minExtent = "8 2";
		visible = "1";
		lineSpacing = "2";
		allowColorChars = "0";
		maxChars = "-1";
		text = "<just:right>Team Kill";
		maxBitmapHeight = "-1";
		selectable = "1";
	};
	new GuiSwatchCtrl(CMG_PointsTeamKillBlocker)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "118 133";
		extent = "36 18";
		minExtent = "8 2";
		visible = "1";
		color = "200 200 200 200";
	};
	CreateMinigameGUI.makeGeneralTabSpace(%tab,20,139);
	%tab.add(CMG_PointsTeamKill);
	%tab.add(CMG_PointsTeamKillText);
	%tab.add(CMG_PointsTeamKillBlocker);
	
	exec("./MinigameGUI_Teams.gui");
	exec("./MinigameGUI_Rules.gui");
	
	CMG_Window.add(CreateMiniGameFrame_TabsList);
	
	//Make it so that CMG_FavsHelper appears on top of the tabs list
	CMG_FavsHelper.delete();
	new GuiSwatchCtrl(CMG_FavsHelper)
	{
		profile = "BlockWindowProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "192 25";
		extent = "269 27";
		minExtent = "8 2";
		visible = "0";
		color = "78 83 235 240";
		
		new GuiTextCtrl() 
		{
			profile = "BlockWindowProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "22 3";
			extent = "225 18";
			minExtent = "8 2";
			visible = "1";
			text = "^^^ Click a number to set favorites ^^^";
			maxLength = "255";
		};
	};
	
	CMG_Window.add(CMG_FavsHelper);
	
	$AddedGameModeGUI = 1;
}

if(!$AddedGameModeGUI)
{
	addGameModeGUIControls();
}

package MinigameGUIClient
{
	function CreateMinigameGUI::clickCreate(%this)
	{
		Parent::clickCreate(%this);
		if($SpaceMods::Client::TeamDM::serverHasMod)
		{
			%data = -1;
			%id = ClientGameModeStorerSO.modeID[$Minigame::TDMGameModeName];
			%string = "MOD" SPC $Minigame::TDMGameModeName;
			
			commandtoserver('SetGameModeData',%data++,%string);
			
			if(ClientGameModeStorerSO.modeUsesTeams[%id])
			{
				TDMClient_FixTeamOrder();
				CreateMinigameGUI.updateTeamsList();
				
				for(%i=0;%i<6;%i++)
				{
					//Torque Game Engine network stuff prevents me from sending the entire uniform at once
					
					//chest		chestCol
					//rArm		rArmCol
					//lArm		lArmCol
					//rHand		rHandCol
					//lHand		lHandCol
					//---------------------------------
					//pants		pantsCol
					//rLeg		rLegCol
					//lLeg		lLegCol
					//hat			hatCol
					//accent		accentCol
					//---------------------------------
					//pack		packCol
					//secondPack		secondPackCol
					//headCol
					//decalName		faceName
					
					//Forcing gaps in the team order won't break it on the server, error checking fixes that
					//Although there might be some messages to clients about updated team orders even when they're the same
					%string = "TEXIST" SPC %i SPC $Minigame::TDMTeamExists[%i];
					if($Minigame::TDMTeamExists[%i])
					{
						commandtoserver('tdmstoreuniform',%i,0,getFields($Minigame::TDMTeamUniform[%i],0,9));
						commandtoserver('tdmstoreuniform',%i,1,getFields($Minigame::TDMTeamUniform[%i],10,19));
						commandtoserver('tdmstoreuniform',%i,2,getFields($Minigame::TDMTeamUniform[%i],20,26));
						
						commandtoserver('tdmstoreluniform',%i,0,getFields($Minigame::TDMLeadUniform[%i],0,9));
						commandtoserver('tdmstoreluniform',%i,1,getFields($Minigame::TDMLeadUniform[%i],10,19));
						commandtoserver('tdmstoreluniform',%i,2,getFields($Minigame::TDMLeadUniform[%i],20,26));
						%string = %string TAB "TNAME"	SPC %i SPC $Minigame::TDMTeamName[%i]
						TAB "TCOL"	SPC %i SPC $Minigame::TDMTeamCol[%i]
						TAB "TASR"	SPC %i SPC $Minigame::TDMTeamSortWeight[%i]
						TAB "TDB"	SPC %i SPC $Minigame::TDMTeamData[%i]
						TAB "TLDB"	SPC %i SPC $Minigame::TDMLeadData[%i];
						
						for(%j=0;%j<5;%j++)
						{
							%string = %string TAB "TSE"	SPC %i SPC %j SPC $Minigame::TDMTeamSE[%i,%j];
						}
						
						for(%j=0;%j<5;%j++)
						{
							%string = %string TAB "TLSE"	SPC %i SPC %j SPC $Minigame::TDMLeadSE[%i,%j];
						}
					}
					else
					{
						for(%j=%i+1;%j<6;%j++)
						{
							if($Minigame::TDMTeamExists[%j])
							{
								messageBoxOK("Create Minigame","For some reason, there seems to be an error in the team order.\n\nPlease report this as a bug, giving the steps you used.");
								return;
							}
						}
					}
					commandtoserver('SetGameModeData',%data++,%string);
				}
				%string = "AS"		SPC $Minigame::TDMAutoSort
				TAB "UNIMODE"	SPC $Minigame::TDMUniform
				TAB "FF" 	SPC $Minigame::TDMFriendlyFire
				TAB "PTK" 	SPC $Minigame::Points::TeamKill
				TAB "TC"	SPC $Minigame::TDMTeamChat
				TAB "TL"	SPC ($Minigame::TDMAutoSort != 0 || $Minigame::TDMTeamLock);
				commandtoserver('SetGameModeData',%data++,%string);
			}
			
			%string = 		"H"	SPC $Minigame::TDMShowHelp
			TAB 	"HN"	SPC $Minigame::TDMHideNames;
			commandtoserver('SetGameModeData',%data++,%string);
			
			//'Rules' Data
			$Minigame::TDMHelpText = txtHelpEnter.getValue();
			%text = $Minigame::TDMHelpText;
			commandtoserver('setModeHelpText',getLine(%text,0));
			for(%i=1;%i<getLineCount(%text);%i++)
			commandtoserver('addModeHelpText',getLine(%text,%i));
			
			for(%i=0;%i<ClientGameModeStorerSO.modeRuleCount[%id];%i++)
			commandtoserver('setGameModeRule',%i,$Minigame::TDMRuleVal[%i]);
			
			for(%i=0;%i<ClientGameModeStorerSO.modeRuleCount[-1];%i++)
			commandtoserver('setGeneralRule',%i,$Minigame::TDMRuleVal[%i+ClientGameModeStorerSO.modeRuleCount[%id]]);
			
			commandtoserver('ProcessGameModeData');
		}
	}
	function CreateMinigameGUI::clickGeneralTab(%this)
	{
		CreateMiniGameTab_GeneralButton.setValue(1);
		CreateMiniGameTab_TeamsButton.setValue(0);
		CreateMiniGameTab_RulesButton.setValue(0);
		for(%i=0;%i<CreateMiniGameFrame_General.getCount();%i++){CreateMiniGameFrame_General.getObject(%i).setVisible(1);}
		for(%i=0;%i<CreateMiniGameFrame_Teams.getCount();%i++){CreateMiniGameFrame_Teams.getObject(%i).setVisible(0);}
		for(%i=0;%i<CreateMiniGameFrame_Rules.getCount();%i++){CreateMiniGameFrame_Rules.getObject(%i).setVisible(0);}
		
		CMG_PointsTeamKillBlocker.setVisible(!ClientGameModeStorerSO.modeUsesTeams[CMG_SelectGamemode.getSelected()]);
		
		CMG_Scroll.setVisible(1);
		CreateMinigameGUI.refresh();
	}
	function CreateMinigameGUI::clickTeamsTab(%this)
	{
		CreateMiniGameTab_GeneralButton.setValue(0);
		CreateMiniGameTab_TeamsButton.setValue(1);
		CreateMiniGameTab_RulesButton.setValue(0);
		for(%i=0;%i<CreateMiniGameFrame_General.getCount();%i++){CreateMiniGameFrame_General.getObject(%i).setVisible(0);}
		for(%i=0;%i<CreateMiniGameFrame_Rules.getCount();%i++){CreateMiniGameFrame_Rules.getObject(%i).setVisible(0);}
		
		CMG_Scroll.setVisible(0);
		
		if(ClientGameModeStorerSO.modeUsesTeams[CMG_SelectGamemode.getSelected()])
		{
			txtNeedMiniError.setVisible(0);
			CreateMiniGameFrame_TeamsOptions.setVisible(1);
		}
		else
		{
			txtNeedMiniError.setVisible(1);
			CreateMiniGameFrame_TeamsOptions.setVisible(0);
			return;
		}
		
		%this.updateTeamsList();
		%this.updatePlayersList();
	}
	function CreateMinigameGUI::clickRulesTab(%this)
	{
		CreateMiniGameTab_GeneralButton.setValue(0);
		CreateMiniGameTab_TeamsButton.setValue(0);
		CreateMiniGameTab_RulesButton.setValue(1);
		for(%i=0;%i<CreateMiniGameFrame_General.getCount();%i++){CreateMiniGameFrame_General.getObject(%i).setVisible(0);}
		for(%i=0;%i<CreateMiniGameFrame_Teams.getCount();%i++){CreateMiniGameFrame_Teams.getObject(%i).setVisible(0);}
		for(%i=0;%i<CreateMiniGameFrame_Rules.getCount();%i++){CreateMiniGameFrame_Rules.getObject(%i).setVisible(1);}
		
		CMG_Scroll.setVisible(0);
		CreateMinigameGUI.setRulesTab();
	}
	function CreateMinigameGUI::onWake(%this,%a,%b,%c)
	{
		%this.setRulesTab();
		%this.clickGeneralTab();
		if($SpaceMods::Client::TeamDM::serverHasMod)
		{
			%o = CMG_ScrollBox;
			%o.resize(%o.tdmClient_x,%o.tdmClient_y,%o.tdmClient_w,%o.tdmClient_exth);
			//Set the description to the now loaded Deathmatch description for the first time
			if($SETTDMHELP)
			{
				$Minigame::TDMHelpText = ClientGameModeStorerSO.modeHelp[0];
				txtHelpEnter.setValue($Minigame::TDMHelpText);
				$SETTDMHELP = "";
			}
			
			if($RunningMinigame)
			{
				for(%i=0;%i<6;%i++)
				{
					$SpaceMods::Client::TeamDM::ServerTeamExists[%i] = 0;
					$SpaceMods::Client::TeamDM::ServerTeamName[%i] = "";
					$SpaceMods::Client::TeamDM::ServerTeamCol[%i] = "";
				}
				commandtoserver('requestTDMTeamList');
			}
			CMG_Window.resize(getWord(CMG_Window.getPosition(),0),getWord(CMG_Window.getPosition(),1),CMG_Window.tdmClient_w,CMG_Window.tdmClient_h+35);
			CMG_SelectGameMode.setVisible(1);
			CMG_SelectGameModeText.setVisible(1);
			for(%i=0;%i<CreateMiniGameFrame_All.getCount();%i++)
			{
				%o = CreateMiniGameFrame_All.getObject(%i);
				%pos = %o.originalPos;
				%ext = %o.getExtent();
				%o.resize(getWord(%pos,0),getWord(%pos,1)+35,getWord(%ext,0),getWord(%ext,1));
			}
			%nextY = 2;
			for(%i=0;%i<4;%i++)
			{
				%o = $SpaceMods::Client::TeamDM::GeneralCat[%i];
				%o.resize(2,%nextY,%o.tdmClient_w,%o.tdmClient_extH);
				%nextY = %nextY + %o.tdmClient_extH + 2;
				for(%j=0;%j<%o.getCount();%j++)
				{
					%ctrl = %o.getObject(%j);
					%cPos = %ctrl.getPosition();
					%cX = getWord(%cPos,0);
					if(%ctrl.tdmClient_y > 0)
						%cY = %ctrl.tdmClient_y+%ctrl.yoffset;
					else
						%cY = getWord(%cPos,1);
					%cExt = %ctrl.getExtent();
					%cW = getWord(%cExt,0);
					%cH = getWord(%cExt,1);
					%ctrl.resize(%cX,%cY,%cW,%cH);
				}
			}
			CreateMinigameFrame_TabsList.setVisible(1);
			
			CMG_PointsTeamKill.setVisible(1);
			CMG_PointsTeamKillText.setVisible(1);
			CMG_PointsTeamKillBlocker.setVisible(!ClientGameModeStorerSO.modeUsesTeams[CMG_SelectGamemode.getSelected()]);
			CMG_HidePlayerNames.setVisible(1);
		}
		else
		{
			%o = CMG_ScrollBox;
			%o.resize(%o.tdmClient_x,%o.tdmClient_y,%o.tdmClient_w,%o.tdmClient_h);
			CMG_Window.resize(getWord(CMG_Window.getPosition(),0),getWord(CMG_Window.getPosition(),1),CMG_Window.tdmClient_w,CMG_Window.tdmClient_h);
			CMG_SelectGameMode.setVisible(0);
			CMG_SelectGameModeText.setVisible(0);
			for(%i=0;%i<CreateMiniGameFrame_All.getCount();%i++)
			{
				%o = CreateMiniGameFrame_All.getObject(%i);
				%pos = %o.originalPos;
				%ext = %o.getExtent();
				%o.resize(getWord(%pos,0),getWord(%pos,1),getWord(%ext,0),getWord(%ext,1));
			}
			%nextY = 2;
			for(%i=0;%i<4;%i++)
			{
				%o = $SpaceMods::Client::TeamDM::GeneralCat[%i];
				%o.resize(2,%nextY,%o.tdmClient_w,%o.tdmClient_h);
				%nextY = %nextY + %o.tdmClient_h + 2;
				for(%j=0;%j<%o.getCount();%j++)
				{
					%ctrl = %o.getObject(%j);
					%cPos = %ctrl.getPosition();
					%cX = getWord(%cPos,0);
					if(%ctrl.tdmClient_y > 0)
						%cY = %ctrl.tdmClient_y;
					else
						%cY = getWord(%cPos,1);
					%cExt = %ctrl.getExtent();
					%cW = getWord(%cExt,0);
					%cH = getWord(%cExt,1);
					%ctrl.resize(%cX,%cY,%cW,%cH);
				}
			}
			CreateMinigameFrame_TabsList.setVisible(0);
			
			CMG_PointsTeamKill.setVisible(0);
			CMG_PointsTeamKillText.setVisible(0);
			CMG_PointsTeamKillBlocker.setVisible(0);
			CMG_HidePlayerNames.setVisible(0);
		}
		Parent::onWake(%this,%a,%b,%c);
	}
	function CreateMinigameGUI::clickFav(%this,%num)
	{
		if(CMG_FavsHelper.isVisible() || !isFile("config/client/MinigameFavorites/" @ %num @ ".cs"))
		{
			if($SpaceMods::Client::TeamDM::serverHasMod)
				$Minigame::TDMHelpText = txtHelpEnter.getValue();
			
			Parent::clickFav(%this,%num);
			return;
		}
		//Set the minigame to normal if you're loading one, in case you're loading from a non-TDM server
		$Minigame::TDMGameModeName = "Deathmatch";
		$Minigame::TDMHelpText = ClientGameModeStorerSO.modeHelp[0];
		$Minigame::Points::TeamKill = -1;
		$Minigame::TDMShowHelp = 0;
		Parent::clickFav(%this,%num);
		if($SpaceMods::Client::TeamDM::serverHasMod)
		{
			txtHelpEnter.setText($Minigame::TDMHelpText);
			%this.clickGeneralTab();
			TDMClient_RefreshLists(); //needed so the lists are populated at least once
			
			for(%id=0;%id<6;%id++)
			{
				if(!$Minigame::TDMTeamExists[%id])
					continue;
				
				for(%j=0;%j<5;%j++)
				{
					if(isObject(("TeamEdit_Inv" @ %j).itemID[$Minigame::TDMTeamSE_name[%id,%j]]))
						$Minigame::TDMTeamSE[%id,%j] = ("TeamEdit_Inv" @ %j).itemID[$Minigame::TDMTeamSE_name[%id,%j]];
					else
					{
						$Minigame::TDMTeamSE[%id,%j] = 0;
						$Minigame::TDMTeamSE_name[%id,%j] = "NONE";
					}
					
					if(isObject(("TeamEdit_Inv" @ %j).itemID[$Minigame::TDMTeamSE_name[%id,%j]]))
						$Minigame::TDMLeadSE[%id,%j] = ("TeamEdit_LInv" @ %j).itemID[$Minigame::TDMLeadSE_name[%id,%j]];
					else
					{
						$Minigame::TDMLeadSE[%id,%j] = 0;
						$Minigame::TDMLeadSE_name[%id,%j] = "NONE";
					}
				}
				
				if(isObject(TeamEdit_PlayerData.typeID[$Minigame::TDMTeamData_name[%id]]))
					$Minigame::TDMTeamData[%id] = TeamEdit_PlayerData.typeID[$Minigame::TDMTeamData_name[%id]];
				else if(isObject(TeamEdit_PlayerData.typeID["Standard Player"]))
				{
					$Minigame::TDMTeamData[%id] = TeamEdit_PlayerData.typeID["Standard Player"];
					$Minigame::TDMTeamData_name[%id] = "Standard Player";
				}
				else
				{
					//it doesn't actually matter since the server fixes it
					$Minigame::TDMTeamData[%id] = 0;
					$Minigame::TDMTeamData_name[%id] = "NONE";
				}
				
				if(isObject(TeamEdit_LeaderData.typeID[$Minigame::TDMLeadData_name[%id]]))
					$Minigame::TDMLeadData[%id] = TeamEdit_LeaderData.typeID[$Minigame::TDMLeadData_name[%id]];
				else if(isObject(TeamEdit_LeaderData.typeID["Standard Player"]))
				{
					$Minigame::TDMLeadData[%id] = TeamEdit_LeaderData.typeID["Standard Player"];
					$Minigame::TDMLeadData_name[%id] = "Standard Player";
				}
				else
				{
					//it doesn't actually matter since the server fixes it
					$Minigame::TDMLeadData[%id] = 0;
					$Minigame::TDMLeadData_name[%id] = "NONE";
				}
			}
		}
	}
	function CreateMinigameGUI::clickColorList(%this)
	{
		Parent::clickColorList(%this);
		if(!$doingtdmrefresh)
		{
			$Minigame::ColorID = CMG_ColorList.getSelected();
		}
	}
	
	function clientcmdAddMinigameColor(%id,%name,%col)
	{
		$doingtdmrefresh = 1;
		Parent::clientcmdAddMinigameColor(%id,%name,%col);		
		CMG_ColorList.setSelected($Minigame::ColorID);
		$doingtdmrefresh = "";
	}
	
	function CreateMinigameGUI::refresh(%this,%part)
	{
		if(%part.isTDMGUIComponent)
			return;
		
		$doingtdmrefresh = 1;
		%r = Parent::refresh(%this,%part);
		$doingtdmrefresh = "";
		
		if($SpaceMods::Client::TeamDM::serverHasMod && %part == CMG_ScrollBox.getID())
		{
			CMG_SelectGamemode.clear();
			for(%i=0;%i<=ClientGameModeStorerSO.modeCount;%i++)
			{
				CMG_SelectGamemode.add(ClientGameModeStorerSO.modeTitle[%i],%i);
				if($Minigame::TDMGameModeName $= ClientGameModeStorerSO.modeTitle[%i])
					%sel = %i;
			}
			CMG_SelectGamemode.setSelected(%sel);
			
			CMG_PointsTeamKillBlocker.setVisible(!ClientGameModeStorerSO.modeUsesTeams[CMG_SelectGamemode.getSelected()]);
			
			CMG_TDMAutoSort.clear();
			CMG_TDMAutoSort.add("Off",0);
			CMG_TDMAutoSort.add("Sort",1);
			CMG_TDMAutoSort.add("Fix",2);
			CMG_TDMAutoSort.setSelected($Minigame::TDMAutoSort);
			
			CMG_TDMUniform.clear();
			CMG_TDMUniform.add("Off",0);
			CMG_TDMUniform.add("Shirt",1);
			CMG_TDMUniform.add("Accessories",2);
			CMG_TDMUniform.add("Full",3);
			CMG_TDMUniform.setSelected($Minigame::TDMUniform);
			
			CMG_ColorBlocker.setVisible($RunningMinigame);
		}
		return %r;
	}
	function CreateMinigameGUI::updateTeamsList(%this)
	{
		lstTDMTeamList.clear();
		lstTDMTeamList.addRow(-1,"NONE");
		for(%i=0;$Minigame::TDMTeamExists[%i];%i++)
		{
			lstTDMTeamList.addRow(%i,$Minigame::TDMTeamName[%i]);
		}
		
		butTDMNewTeam.setActive(!$Minigame::TDMTeamExists[5]);
	}
	function CreateMinigameGUI::updatePlayersList(%this)
	{
		commandtoserver('requestTDMPlayerList');
		clientcmdclearteamDMplayerdata();
	}
	function clientcmdclearteamDMplayerdata()
	{
		TDM_PlayerBlocker.setVisible(1);
		lstTDMPlayerList.clear();
	}
	function clientcmdteamDMplayerdata(%i,%name,%team,%l)
	{
		if(%i == -1)
		{
			TDM_PlayerBlocker.setVisible(1);
			butTDMSetTeam.setActive(0);
			butTDMSetLead.setActive(0);
			lstTDMPlayerList.clear();
			lstTDMPlayerList.addRow(0,(%name ? $pref::Player::LANName : $pref::Player::NetName) TAB "NONE" SPC "");
			lstTDMPlayerList.sort(0,1);
		}
		else
		{
			//It uses the server's name for the team because you can edit them or remove them etc. and then the ID wouldn't exist
			TDM_PlayerBlocker.setVisible(0);
			butTDMSetTeam.setActive(1);
			butTDMSetLead.setActive(1);
			lstTDMPlayerList.addRow(%i,%name TAB %team SPC (%l ? "*" : ""));
			lstTDMPlayerList.sort(0,1);
		}
	}
	function clientcmdteamDMteamdata(%id,%ex,%name,%col)
	{
		$SpaceMods::Client::TeamDM::ServerTeamExists[%id] = %ex;
		$SpaceMods::Client::TeamDM::ServerTeamName[%id] = %name;
		$SpaceMods::Client::TeamDM::ServerTeamCol[%id] = %col;
	}
	function LoadingGUI::onWake(%this)
	{
		Parent::onWake(%this);
		
		$SpaceMods::Client::TeamDM::serverHasMod = 0;
		
		$Minigame::TDMGameModeName = "Deathmatch";
		$SETTDMHELP = 1;
		$Minigame::TDMFriendlyFire = 0;
		$Minigame::Points::TeamKill = -1;
		$Minigame::TDMAutoSort = 0;
		$Minigame::TDMUniform = 2;
		$Minigame::TDMTeamChat = 1;
		$Minigame::TDMHideNames = 0;
		
		for(%i=0;%i<6;%i++)
		{
			$Minigame::TDMTeamExists[%i] = 0;
			$Minigame::TDMTeamName[%i] = "";
			$Minigame::TDMTeamCol[%i] = "";
			$Minigame::TDMTeamUniform[%i] = "";
			$Minigame::TDMLeadUniform[%i] = "";
			$Minigame::TDMTeamSortWeight[%i] = "";
			
			for(%j=0;%j<5;%j++)
			{
				$Minigame::TDMTeamSE[%i,%j] = "";
				$Minigame::TDMTeamSE_name[%i,%j] = "";
				$Minigame::TDMLeadSE[%i,%j] = "";
				$Minigame::TDMLeadSE_name[%i,%j] = "";
			}
			
			$Minigame::TDMTeamData[%i] = "";
			$Minigame::TDMTeamData_name[%i] = "";
			$Minigame::TDMLeadData[%i] = "";
			$Minigame::TDMLeadData_name[%i] = "";
			
			$SpaceMods::Client::TeamDM::ServerTeamExists[%i] = 0;
			$SpaceMods::Client::TeamDM::ServerTeamName[%i] = "";
			$SpaceMods::Client::TeamDM::ServerTeamCol[%i] = "";
		}
	}
	function clientcmdteamDMServerConfirm()
	{
		$SpaceMods::Client::TeamDM::serverHasMod = 1;
		
		if(isObject(ClientGameModeStorerSO))
			ClientGameModeStorerSO.delete();
		
		new ScriptObject(ClientGameModeStorerSO){modeCount=-1;};
		
		commandtoserver('requestTDMGameModes');
	}
	function clientcmdregisterGameMode(%title,%usesTeams,%specialTeams)
	{
		if(ClientGameModeStorerSO.modeID[%title] !$= "")
			return;
		
		ClientGameModeStorerSO.modeCount++;
		ClientGameModeStorerSO.modeID[%title] = ClientGameModeStorerSO.modeCount;
		ClientGameModeStorerSO.modeTitle[ClientGameModeStorerSO.modeCount] = %title;
		ClientGameModeStorerSO.modeUsesTeams[ClientGameModeStorerSO.modeCount] = %usesTeams;
		ClientGameModeStorerSO.modeSpecialTeams[ClientGameModeStorerSO.modeCount] = %specialTeams;
		ClientGameModeStorerSO.modeRuleCount[ClientGameModeStorerSO.modeCount] = 0;
	}
	function clientcmdAddGameModeRule(%title,%text,%rule,%default)
	{
		if(ClientGameModeStorerSO.modeID[%title] $= "")
			return;
		%id = ClientGameModeStorerSO.modeID[%title];
		ClientGameModeStorerSO.modeRuleTxt[%id,ClientGameModeStorerSO.modeRuleCount[%id]] = %text;
		ClientGameModeStorerSO.modeRuleStr[%id,ClientGameModeStorerSO.modeRuleCount[%id]] = %rule;
		ClientGameModeStorerSO.modeRuleDef[%id,ClientGameModeStorerSO.modeRuleCount[%id]] = %default;
		ClientGameModeStorerSO.modeRuleCount[%id]++;
	}
	function clientcmdAddGeneralRule(%text,%rule,%default)
	{
		%id = -1;
		if(ClientGameModeStorerSO.modeRuleCount[%id] $= "")
			ClientGameModeStorerSO.modeRuleCount[%id] = 0;
		
		ClientGameModeStorerSO.modeRuleTxt[%id,ClientGameModeStorerSO.modeRuleCount[%id]] = %text;
		ClientGameModeStorerSO.modeRuleStr[%id,ClientGameModeStorerSO.modeRuleCount[%id]] = %rule;
		ClientGameModeStorerSO.modeRuleDef[%id,ClientGameModeStorerSO.modeRuleCount[%id]] = %default;
		ClientGameModeStorerSO.modeRuleCount[%id]++;
	}
	function clientcmdaddGameModeHelp(%title,%text)
	{
		if(ClientGameModeStorerSO.modeID[%title] $= "")
			return;
		%id = ClientGameModeStorerSO.modeID[%title];
		if(ClientGameModeStorerSO.modeHelp[%id] $= "")
			ClientGameModeStorerSO.modeHelp[%id] = %text;
		else
			ClientGameModeStorerSO.modeHelp[%id] = ClientGameModeStorerSO.modeHelp[%id] NL %text;
	}
	function CMG_SelectGamemode::onSelect(%this,%a,%b)
	{
		if(%b !$= $Minigame::TDMGameModeName)
		{
			$Minigame::TDMGameModeName = %b;
			$Minigame::TDMHelpText = ClientGameModeStorerSO.modeHelp[%a];
			
			for(%i=0;%i<ClientGameModeStorerSO.modeRuleCount[%a];%i++)
			$Minigame::TDMRuleVal[%i] = ClientGameModeStorerSO.modeRuleDef[%a,%i];
			
			$Minigame::TDMShowHelp = (%b !$= "Deathmatch");
			
			txtHelpEnter.setText($Minigame::TDMHelpText);
			txtHelpName.setText(%b);
			
			if(!ClientGameModeStorerSO.modeUsesTeams[%a] || ClientGameModeStorerSO.modeSpecialTeams[%a])
			{
				$Minigame::TDMFriendlyFire = 0;
				$Minigame::Points::TeamKill = -1;
				$Minigame::TDMAutoSort = 0;
				$Minigame::TDMUniform = 2;
				$Minigame::TDMTeamChat = 1;
				
				for(%i=0;%i<6;%i++)
				{
					$Minigame::TDMTeamExists[%i] = 0;
					$Minigame::TDMTeamCol[%i] = "";
					$Minigame::TDMTeamName[%i] = "";
					$Minigame::TDMTeamUniform[%i] = "";
					$Minigame::TDMLeadUniform[%i] = "";
					$Minigame::TDMTeamSortWeight[%i] = "";
					
					for(%j=0;%j<5;%j++)
					{
						$Minigame::TDMTeamSE[%i,%j] = "";
						$Minigame::TDMTeamSE_name[%i,%j] = "";
						$Minigame::TDMLeadSE[%i,%j] = "";
						$Minigame::TDMLeadSE_name[%i,%j] = "";
					}
					
					$Minigame::TDMTeamData[%i] = "";
					$Minigame::TDMTeamData_name[%i] = "";
					$Minigame::TDMLeadData[%i] = "";
					$Minigame::TDMLeadData_name[%i] = "";
				}
				if(ClientGameModeStorerSO.modeSpecialTeams[%a])
					commandtoserver('tdmRequestModeSpecial',%a);
			}
			
			CreateMinigameGUI.refresh();
		}
	}
	function CMG_TDMAutoSort::onSelect(%this,%a,%b)
	{
		$Minigame::TDMAutoSort = %a;
		CMG_TeamLock.setActive((%a == 0));
	}
	function CMG_TDMUniform::onSelect(%this,%a,%b)
	{
		$Minigame::TDMUniform = %a;
	}
	function TeamEditGui::onWake(%this)
	{
		if(isObject(TeamEditGui_ColorMenu))
			TeamEditGui_ColorMenu.delete();
	}
	function TeamEditGui::createColorMenu(%this,%obj) //I wouldn't have to do this if we had access to the client source
	{
		if(isObject(TeamEditGui_ColorMenu))
		{
			TeamEditGui_ColorMenu.delete();
			return;
		}
		
		if(isObject(Avatar_ColorMenu))
			Avatar_ColorMenu.delete();
		
		WrenchEventsDlg::createColorMenu(%this.getObject(0),%obj);
		
		Avatar_ColorMenu.setName("TeamEditGui_ColorMenu");
		
		TeamEditWindow.add(TeamEditGui_ColorMenu);
		
		%ext = TeamEditGui_ColorMenu.getExtent();
		%w = getWord(%ext,0);
		%h = getWord(%ext,1);
		
		%objPos = TeamEdit_Colour.getPosition();
		%objX = getWord(%objPos,0);
		%objY = getWord(%objPos,1);
		
		%objExt = TeamEdit_Colour.getExtent();
		%objW = getWord(%objExt,0);
		%objH = getWord(%objExt,1);
		
		TeamEditGui_ColorMenu.resize(%objX+%objW,%objY,%w,%h);
		
		for(%i=0;%i<64;%i++)
		{
			%num = (%i*2)+1;
			
			if(%num >= TeamEditGui_ColorMenu.getObject(0).getCount())
				break;
			
			%o = TeamEditGui_ColorMenu.getObject(0).getObject(%num);
			%o.command = "TeamEditGui.pickColor(" @ %i @ ");";
		}
	}
	function TeamEditGui::pickColor(%this,%c)
	{
		if(isObject(TeamEditGui_ColorMenu))
			TeamEditGui_ColorMenu.delete();
		TeamEdit_Colour.value = %c;
		
		%col = getColorIDTable(%c);
		
		TeamEdit_Colour.setColor(%col);
	}
	function TDMClient_NewTeam()
	{
		if($Minigame::TDMTeamExists[5])
			return;
		
		for(%i=0;$Minigame::TDMTeamExists[%i];%i++){}
		
		$SpaceMods::Client::TeamDM::CurrentEditTeam = %i;
		$SpaceMods::Client::TeamDM::EditingTeam = 2;
		
		canvas.pushDialog(TeamEditGui);
		
		TeamEdit_DisbandButton.setVisible(0);
		
		TeamEdit_Colour.setColor(getColorIDTable(0));
		TeamEdit_Colour.value = 0;
		
		TeamEdit_Name.setValue("");
		teamEditWindow.setValue("Create Team");
		
		TeamEdit_SortWeight.setValue(1);
		
		TDMClient_RefreshLists();
		
		for(%j=0;%j<5;%j++)
		{
			%item = ("CMG_StartEquip" @ %j).getText();
			if(isObject(("TeamEdit_Inv" @ %j).itemID[%item]))
			{
				("TeamEdit_Inv" @ %j).setSelected(("TeamEdit_Inv" @ %j).itemID[%item]);
				("TeamEdit_LInv" @ %j).setSelected(("TeamEdit_Inv" @ %j).itemID[%item]);
			}
			else
			{
				("TeamEdit_Inv" @ %j).setSelected(0);
				("TeamEdit_LInv" @ %j).setSelected(0);
			}
		}
		
		%data = CMG_PlayerDataBlock.getText();  
		if(isObject(TeamEdit_PlayerData.typeID[%data]))
		{
			TeamEdit_PlayerData.setSelected(TeamEdit_PlayerData.typeID[%data]);
			TeamEdit_LeaderData.setSelected(TeamEdit_PlayerData.typeID[%data]);
		}
		else if(isObject(TeamEdit_PlayerData.typeID["Standard Player"]))
		{
			TeamEdit_PlayerData.setSelected(TeamEdit_PlayerData.typeID["Standard Player"]);
			TeamEdit_LeaderData.setSelected(TeamEdit_PlayerData.typeID["Standard Player"]);
		}
		else
		{
			TeamEdit_PlayerData.setSelected(0);
			TeamEdit_LeaderData.setSelected(0);
		}
	}
	function TDMClient_EditTeam(%id)
	{
		if(!$Minigame::TDMTeamExists[%id])
		{
			messageBoxOK("Edit Team","Pick a team to edit.");
			return;
		}
		
		$SpaceMods::Client::TeamDM::CurrentEditTeam = %id;
		$SpaceMods::Client::TeamDM::EditingTeam = 1;
		
		canvas.pushDialog(TeamEditGui);
		
		TeamEdit_DisbandButton.setVisible(1);
		
		TeamEdit_Colour.setColor(getColorIDTable($Minigame::TDMTeamCol[%id]));
		TeamEdit_Colour.value = $Minigame::TDMTeamCol[%id];
		
		TeamEdit_Name.setValue($Minigame::TDMTeamName[%id]);
		teamEditWindow.setValue($Minigame::TDMTeamName[%id]);
		
		TeamEdit_SortWeight.setValue($Minigame::TDMTeamSortWeight[%id]);
		
		TDMClient_RefreshLists();
		
		for(%j=0;%j<5;%j++)
		{
			("TeamEdit_Inv" @ %j).setSelected($Minigame::TDMTeamSE[%id,%j]);
			("TeamEdit_LInv" @ %j).setSelected($Minigame::TDMLeadSE[%id,%j]);
		}
		
		TeamEdit_PlayerData.setSelected($Minigame::TDMTeamData[%id]);
		TeamEdit_LeaderData.setSelected($Minigame::TDMLeadData[%id]);
	}
	function TDMClient_TeamEditDone()
	{
		%id = $SpaceMods::Client::TeamDM::CurrentEditTeam;
		if(%id < 0 || %id > 5)
			return;
		
		if(!isInt(%id))
			return;
		
		if($SpaceMods::Client::TeamDM::EditingTeam == 0)
			return;
		
		if($SpaceMods::Client::TeamDM::EditingTeam == 2)
			%title = "Create Team";
		else
			%title = "Edit Team";
		
		%name = TeamEdit_Name.getValue();
		
		%temp = stripMLControlChars(%b);
		while(%temp !$= %b)
		{
			%b = %temp;
			%temp = stripMLControlChars(%b);
		}
		
		%name = trim(%name);
		
		if(%name $= "")
		{
			messageBoxOK(%title,"Your team must have a name.");
			return;
		}
		
		for(%i=0;%i<6;%i++)
		{
			%j = $SpaceMods::Client::TeamDM::CurrentEditTeam;
			if(%i == %j)
				continue;
			if($Minigame::TDMTeamName[%i] $= %name)
			{
				messageBoxOK(%title,"Another team already exists with that name.");
				return;
			}
		}
		
		$Minigame::TDMTeamExists[%id] = 1;
		$Minigame::TDMTeamName[%id] = %name;
		$Minigame::TDMTeamCol[%id] = TeamEdit_Colour.value;
		$Minigame::TDMTeamSortWeight[%id] = TeamEdit_SortWeight.getValue();
		
		for(%j=0;%j<5;%j++)
		{
			$Minigame::TDMTeamSE[%id,%j] = ("TeamEdit_Inv" @ %j).getSelected();
			$Minigame::TDMTeamSE_name[%id,%j] = ("TeamEdit_Inv" @ %j).getTextByID($Minigame::TDMTeamSE[%id,%j]);
			$Minigame::TDMLeadSE[%id,%j] = ("TeamEdit_LInv" @ %j).getSelected();
			$Minigame::TDMLeadSE_name[%id,%j] = ("TeamEdit_LInv" @ %j).getTextByID($Minigame::TDMLeadSE[%id,%j]);
		}
		
		$Minigame::TDMTeamData[%id] = TeamEdit_PlayerData.getSelected();
		$Minigame::TDMTeamData_name[%id] = TeamEdit_PlayerData.getTextByID($Minigame::TDMTeamData[%id]);
		$Minigame::TDMLeadData[%id] = TeamEdit_LeaderData.getSelected();
		$Minigame::TDMLeadData_name[%id] = TeamEdit_LeaderData.getTextByID($Minigame::TDMLeadData[%id]);
		
		$SpaceMods::Client::TeamDM::EditingTeam = 0;
		$SpaceMods::Client::TeamDM::CurrentEditTeam = -1;
		canvas.popDialog("teamEditGUI");
		CreateMinigameGUI.updateTeamsList();
		CreateMinigameGUI.updatePlayersList();
	}
	function TDMClient_RefreshLists()
	{
		for(%j=0;%j<5;%j++)
		{
			("TeamEdit_Inv" @ %j).clear();
			("TeamEdit_LInv" @ %j).clear();
		}
		
		TeamEdit_PlayerData.clear();
		TeamEdit_LeaderData.clear();
		
		//Using the Avatar GUI inserts a DummyPlayer datablock and causes count to be greater than zero
		if(DatablockGroup.getCount() > 2)
			%group = DatablockGroup;
		else
			%group = ServerConnection;
		
		%items = -1;
		%players = -1;
		
		for(%i=0;%i<%group.getCount();%i++)
		{
			%o = %group.getObject(%i);
			if(%o.getClassName() $= "ItemData" && %o.uiName !$= "")
			{
				for(%j=0;%j<5;%j++)
				{
					("TeamEdit_Inv" @ %j).add(%o.uiName,%o.getID());
					("TeamEdit_Inv" @ %j).itemID[%o.uiName] = %o.getID();
					("TeamEdit_LInv" @ %j).add(%o.uiName,%o.getID());
					("TeamEdit_LInv" @ %j).itemID[%o.uiName] = %o.getID();
				}
			}
			else if(%o.getClassName() $= "PlayerData" && %o.uiName !$= "")
			{
				TeamEdit_PlayerData.add(%o.uiName,%o.getID());
				TeamEdit_PlayerData.typeID[%o.uiName] = %o.getID();
				TeamEdit_LeaderData.add(%o.uiName,%o.getID());
				TeamEdit_LeaderData.typeID[%o.uiName] = %o.getID();
			}
		}
		
		for(%j=0;%j<5;%j++)
		{
			("TeamEdit_Inv" @ %j).sort();
			("TeamEdit_LInv" @ %j).sort();
			
			("TeamEdit_Inv" @ %j).addFront("NONE",0);
			("TeamEdit_LInv" @ %j).addFront("NONE",0);
		}
	}
	function TDMClient_UpdateTeamName(%name)
	{
		if(%name !$= "")
			teamEditWindow.setValue(%name);
		else if($SpaceMods::Client::TeamDM::EditingTeam == 1)
			teamEditWindow.setValue("Edit Team");
		else
			teamEditWindow.setValue("Create Team");
	}
	function TDMClient_SetTeam(%player,%team)
	{
		if(!$runningMinigame)
		{
			messageBoxOK("Set Team","You need to create the minigame before you can set teams."); //someone decided they'd try and break the GUI?
			return;
		}
		
		if(%player == -1)
		{
			messageBoxOK("Set Team","Select a player to move.");
			return;
		}
		
		if(%team != -1 && (!$SpaceMods::Client::TeamDM::ServerTeamExists[%team] || $Minigame::TDMTeamName[%team] !$= $SpaceMods::Client::TeamDM::ServerTeamName[%team] || $Minigame::TDMTeamCol[%team] != $SpaceMods::Client::TeamDM::ServerTeamCol[%team]))
		{
			messageBoxOK("Set Team","This team has been edited. Update the minigame before setting players into this team.");
			return;
		}
		
		commandtoserver('tdmGUISetTeam',%player,%team);
	}
	function TDMClient_SetLead(%player,%team)
	{
		if(!$runningMinigame)
		{
			messageBoxOK("Set Leader","You need to create the minigame before you can set team leaders."); //someone decided they'd try and break the GUI?
			return;
		}
		
		if(%player == -1)
		{
			messageBoxOK("Set Leader","Select a player to move.");
			return;
		}
		
		if(%team != -1 && (!$SpaceMods::Client::TeamDM::ServerTeamExists[%team] || $Minigame::TDMTeamName[%team] !$= $SpaceMods::Client::TeamDM::ServerTeamName[%team] || $Minigame::TDMTeamCol[%team] != $SpaceMods::Client::TeamDM::ServerTeamCol[%team]))
		{
			messageBoxOK("Set Leader","This team has been edited. Update the minigame before setting this team's leader.");
			return;
		}
		
		commandtoserver('tdmGUISetLead',%player,%team);
	}
	function TDMClient_ClearTeams()
	{
		for(%i=0;%i<6;%i++)
		{
			$Minigame::TDMTeamExists[%i] = 0;
			$Minigame::TDMTeamName[%i] = "";
			$Minigame::TDMTeamCol[%i] = "";
			$Minigame::TDMTeamUniform[%i] = "";
			$Minigame::TDMLeadUniform[%i] = "";
			$Minigame::TDMTeamSortWeight[%i] = "";
			
			for(%j=0;%j<5;%j++)
			{
				$Minigame::TDMTeamSE[%i,%j] = "";
				$Minigame::TDMTeamSE_name[%i,%j] = "";
				$Minigame::TDMLeadSE[%i,%j] = "";
				$Minigame::TDMLeadSE_name[%i,%j] = "";
			}
			
			$Minigame::TDMTeamData[%i] = "";
			$Minigame::TDMTeamData_name[%i] = "";
			$Minigame::TDMLeadData[%i] = "";
			$Minigame::TDMLeadData_name[%i] = "";
		}
		CreateMinigameGUI.updateTeamsList();
	}
	function TDMClient_DisbandTeam()
	{
		%id = $SpaceMods::Client::TeamDM::CurrentEditTeam;
		$SpaceMods::Client::TeamDM::CurrentEditTeam = -1;
		$SpaceMods::Client::TeamDM::EditingTeam = 0;
		
		canvas.popDialog(teamEditGUI);
		
		if(!$Minigame::TDMTeamExists[%id])
			return;
		
		$Minigame::TDMTeamExists[%id] = 0;
		$Minigame::TDMTeamName[%id] = "";
		$Minigame::TDMTeamCol[%id] = "";
		$Minigame::TDMTeamUniform[%id] = "";
		$Minigame::TDMLeadUniform[%id] = "";
		$Minigame::TDMTeamSortWeight[%id] = "";
		
		for(%j=0;%j<5;%j++)
		{
			$Minigame::TDMTeamSE[%id,%j] = "";
			$Minigame::TDMTeamSE_name[%id,%j] = "";
			$Minigame::TDMLeadSE[%id,%j] = "";
			$Minigame::TDMLeadSE_name[%id,%j] = "";
		}
		
		$Minigame::TDMTeamData[%id] = "";
		$Minigame::TDMTeamData_name[%id] = "";
		$Minigame::TDMLeadData[%id] = "";
		$Minigame::TDMLeadData_name[%id] = "";
		TDMClient_FixTeamOrder();
		CreateMinigameGUI.updateTeamsList();
	}
	function TDMClient_FixTeamOrder()
	{
		%lastEmpty = -1;
		for(%i=0;%i<6;%i++)
		{
			if(%lastEmpty == -1)
			{
				if(!$Minigame::TDMTeamExists[%i])
					%lastEmpty = %i;
			}
			else
			{
				if($Minigame::TDMTeamExists[%i])
				{
					$Minigame::TDMTeamExists[%lastEmpty] = 1;
					$Minigame::TDMTeamName[%lastEmpty] = $Minigame::TDMTeamName[%i];
					$Minigame::TDMTeamCol[%lastEmpty] = $Minigame::TDMTeamCol[%i];
					$Minigame::TDMTeamUniform[%lastEmpty] = $Minigame::TDMTeamUniform[%i];
					$Minigame::TDMLeadUniform[%lastEmpty] = $Minigame::TDMLeadUniform[%i];
					$Minigame::TDMTeamSortWeight[%lastEmpty] = $Minigame::TDMTeamSortWeight[%i];
					
					$Minigame::TDMTeamData[%lastEmpty] = $Minigame::TDMTeamData[%i];
					$Minigame::TDMTeamData_name[%lastEmpty] = $Minigame::TDMTeamData_name[%i];
					$Minigame::TDMLeadData[%lastEmpty] = $Minigame::TDMLeadData[%i];
					$Minigame::TDMLeadData_name[%lastEmpty] = $Minigame::TDMLeadData_name[%i];
					
					for(%j=0;%j<5;%j++)
					{
						$Minigame::TDMTeamSE[%lastEmpty,%j] = $Minigame::TDMTeamSE[%i,%j];
						$Minigame::TDMTeamSE_name[%lastEmpty,%j] = $Minigame::TDMTeamSE_name[%i,%j];
						$Minigame::TDMLeadSE[%lastEmpty,%j] = $Minigame::TDMLeadSE[%i,%j];
						$Minigame::TDMLeadSE_name[%lastEmpty,%j] = $Minigame::TDMLeadSE_lead[%i,%j];
					}
					
					$Minigame::TDMTeamExists[%i] = 0;
					$Minigame::TDMTeamName[%i] = "";
					$Minigame::TDMTeamCol[%i] = "";
					$Minigame::TDMTeamUniform[%i] = "";
					$Minigame::TDMLeadUniform[%i] = "";
					$Minigame::TDMTeamSortWeight[%i] = "";
					
					$Minigame::TDMTeamData[%i] = "";
					$Minigame::TDMTeamData_name[%i] = "";
					$Minigame::TDMLeadData[%i] = "";
					$Minigame::TDMLeadData_name[%i] = "";
					
					for(%j=0;%j<5;%j++)
					{
						$Minigame::TDMTeamSE[%i,%j] = "";
						$Minigame::TDMTeamSE_name[%i,%j] = "";
						$Minigame::TDMLeadSE[%i,%j] = "";
						$Minigame::TDMLeadSE_name[%i,%j] = "";
					}
					
					%i = %lastEmpty;
					%lastEmpty = -1;
				}
			}
		}
	}
	//Special Team Data
	//These commands allow certain game modes to send special data for teams to be automatically added. Note that they can still be edited after this - use
	//team IDs, not names if you're going to make game modes use them.
	function clientcmdtdmSpecialClearTeams()
	{
		for(%i=0;%i<6;%i++)
		{
			$Minigame::TDMTeamExists[%i] = 0;
			$Minigame::TDMTeamName[%i] = "";
			$Minigame::TDMTeamCol[%i] = "";
			$Minigame::TDMTeamUniform[%i] = "";
			$Minigame::TDMLeadUniform[%i] = "";
			$Minigame::TDMTeamSortWeight[%i] = "";
			
			for(%j=0;%j<5;%j++)
			{
				$Minigame::TDMTeamSE[%i,%j] = "";
				$Minigame::TDMTeamSE_name[%i,%j] = "";
				$Minigame::TDMLeadSE[%i,%j] = "";
				$Minigame::TDMLeadSE_name[%i,%j] = "";
			}
			
			$Minigame::TDMTeamData[%i] = "";
			$Minigame::TDMTeamData_name[%i] = "";
			$Minigame::TDMLeadData[%i] = "";
			$Minigame::TDMLeadData_name[%i] = "";
		}
		CreateMinigameGUI.updateTeamsList();
	}
	function clientcmdtdmSpecialSendTeam(%id,%data)
	{
		if(%id < 0 || %id > 5)
			return;
		
		if(!isInt(%id))
			return;
		
		%name = getField(%data,0);
		
		%temp = stripMLControlChars(%b);
		while(%temp !$= %b)
		{
			%b = %temp;
			%temp = stripMLControlChars(%b);
		}
		
		%name = trim(%name);
		
		if(%name $= "")
		{
			echo("clientcmdtdmSpecialSendTeam - recieved invalid name!");
			return;
		}
		
		for(%i=0;%i<6;%i++)
		{
			if(%i == %id)
				continue;
			if($Minigame::TDMTeamName[%i] $= %name)
			{
				echo("clientcmdtdmSpecialSendTeam - recieved invalid name!");
				return;
			}
		}
		
		$Minigame::TDMTeamExists[%id] = 1;
		$Minigame::TDMTeamName[%id] = %name;
		$Minigame::TDMTeamCol[%id] = getField(%data,1);
		$Minigame::TDMTeamSortWeight[%id] = getField(%data,2);
		
		TDMClient_RefreshLists(); //needed so the lists are populated at least once
		
		for(%j=0;%j<5;%j++)
		{
			$Minigame::TDMTeamSE[%id,%j] = getField(%data,4+%j);
			$Minigame::TDMLeadSE[%id,%j] = getField(%data,10+%j);
			
			if(isObject($Minigame::TDMTeamSE[%id,%j]))
				$Minigame::TDMTeamSE_name[%id,%j] = ("TeamEdit_Inv" @ %j).getTextByID($Minigame::TDMTeamSE[%id,%j]);
			else
				$Minigame::TDMTeamSE_name[%id,%j] = "NONE";
			
			if(isObject($Minigame::TDMLeadSE[%id,%j]))
				$Minigame::TDMLeadSE_name[%id,%j] = ("TeamEdit_Inv" @ %j).getTextByID($Minigame::TDMLeadSE[%id,%j]);
			else
				$Minigame::TDMLeadSE_name[%id,%j] = "NONE";
		}
		
		$Minigame::TDMTeamData[%id] = getField(%data,3);
		$Minigame::TDMLeadData[%id] = getField(%data,9);
		
		if(isObject($Minigame::TDMTeamData[%id,%j]))
			$Minigame::TDMTeamData_name[%id,%j] = TeamEdit_PlayerData.getTextByID($Minigame::TDMTeamData[%id,%j]);
		else
			$Minigame::TDMTeamData_name[%id,%j] = "Standard Player";
		
		if(isObject($Minigame::TDMLeadData[%id,%j]))
			$Minigame::TDMLeadData_name[%id,%j] = TeamEdit_LeaderData.getTextByID($Minigame::TDMLeadData[%id,%j]);
		else
			$Minigame::TDMLeadData_name[%id,%j] = "Standard Player";
		
		CreateMinigameGUI.updateTeamsList();
	}
	function clientcmdtdmSpecialStoreUniform(%team,%ind,%data)
	{
		if(!isInt(%team) || %team < 0 || %team > 5)
			return;
		if(!isInt(%ind) || %ind < 0 || %ind > 3)
			return;
		
		$tdmStoreUniform_part[%team,%ind] = %data;
		
		if(%ind == 2)
		{
			$Minigame::TDMTeamUniform[%team] = trim($tdmStoreUniform_part[%team,0] TAB
			$tdmStoreUniform_part[%team,1] TAB
			$tdmStoreUniform_part[%team,2]);
		}
	}
	function clientcmdtdmSpecialStoreLUniform(%team,%ind,%data)
	{
		if(!isInt(%team) || %team < 0 || %team > 5)
			return;
		if(!isInt(%ind) || %ind < 0 || %ind > 3)
			return;
		
		$tdmStoreLUniform_part[%team,%ind] = %data;
		
		if(%ind == 2)
		{
			$Minigame::TDMLeadUniform[%team] = trim($tdmStoreLUniform_part[%team,0] TAB
			$tdmStoreLUniform_part[%team,1] TAB
			$tdmStoreLUniform_part[%team,2]);
		}
	}
	
	//Hacking the avatar GUI to do what I want. Yay.
	//Your 'Normal' avatar prefs are kept in between setting parts in case you crash/get kicked/etc. and have those prefs saved
	//Effectively, it stores:
	//- Your normal avatar [as $Pref::Avatar and as $Backup::Avatar]
	//- Current Editing Team Avatar [As $Avatar::HackyBackupAvatar]
	//- [6x] Team Player Avatar [As $Minigame::TDMTeamUniform[team]]
	//- [6x] Team Leader Avatar [As $Minigame::TDMLeadUniform[team]]
	function TDMClient_UniMember()
	{
		$Avatar::HackyTeamAvatar = 1;
		$Avatar::HackyTeamAvatar_mode = 0;
		saveBackupAvatar();
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,0);
		Avatar_Prefix.getGroup().setVisible(0);
		Avatar_Name.getGroup().setVisible(0);
		canvas.pushDialog(AvatarGUI);
		AvatarGUI.onWake();
		loadBackupAvatar();
	}
	function TDMClient_UniLeader()
	{
		$Avatar::HackyTeamAvatar = 1;
		$Avatar::HackyTeamAvatar_mode = 1;
		saveBackupAvatar();
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,1);
		Avatar_Prefix.getGroup().setVisible(0);
		Avatar_Name.getGroup().setVisible(0);
		canvas.pushDialog(AvatarGUI);
		AvatarGUI.onWake();
		loadBackupAvatar();
	}
	function TDMClient_UniDefault()
	{
		$Minigame::TDMTeamUniform[$SpaceMods::Client::TeamDM::CurrentEditTeam] = "";
		$Minigame::TDMLeadUniform[$SpaceMods::Client::TeamDM::CurrentEditTeam] = "";
	}
	function saveBackupAvatar()
	{
		$Backup::Avatar::Accent		= $pref::Avatar::Accent;
		$Backup::Avatar::AccentColor		= $pref::Avatar::AccentColor;
		$Backup::Avatar::Chest		= $Pref::Avatar::Chest;
		$Backup::Avatar::ChestColor		= $pref::Avatar::ChestColor;	//I don't know, but apparently it's vital even though it isn't used
		$Backup::Avatar::DecalColor		= $pref::Avatar::DecalColor;	//Seems to be 'Decal ID'
		$Backup::Avatar::DecalName		= $Pref::Avatar::DecalName;
		$Backup::Avatar::FaceColor		= $pref::Avatar::FaceColor;	//Seems to be 'Face ID'
		$Backup::Avatar::FaceName		= $Pref::Avatar::FaceName;
		$Backup::Avatar::Hat			= $pref::Avatar::Hat;
		$Backup::Avatar::HatColor		= $pref::Avatar::HatColor;
		$Backup::Avatar::HeadColor		= $pref::Avatar::HeadColor;
		$Backup::Avatar::Hip			= $Pref::Avatar::Hip;
		$Backup::Avatar::HipColor		= $pref::Avatar::HipColor;
		$Backup::Avatar::LArm			= $Pref::Avatar::LArm;
		$Backup::Avatar::LArmColor		= $pref::Avatar::LArmColor;
		$Backup::Avatar::LHand		= $Pref::Avatar::LHand;
		$Backup::Avatar::LHandColor		= $pref::Avatar::LHandColor;
		$Backup::Avatar::LLeg			= $Pref::Avatar::LLeg;
		$Backup::Avatar::LLegColor		= $pref::Avatar::LLegColor;
		$Backup::Avatar::Pack			= $pref::Avatar::Pack;
		$Backup::Avatar::PackColor		= $pref::Avatar::PackColor;
		$Backup::Avatar::RArm			= $Pref::Avatar::RArm;
		$Backup::Avatar::RArmColor		= $pref::Avatar::RArmColor;
		$Backup::Avatar::RHand		= $Pref::Avatar::RHand;
		$Backup::Avatar::RHandColor		= $pref::Avatar::RHandColor;
		$Backup::Avatar::RLeg			= $Pref::Avatar::RLeg;
		$Backup::Avatar::RLegColor		= $pref::Avatar::RLegColor;
		$Backup::Avatar::SecondPack		= $Pref::Avatar::SecondPack;
		$Backup::Avatar::SecondPackColor	= $pref::Avatar::SecondPackColor;
		$Backup::Avatar::TorsoColor		= $pref::Avatar::TorsoColor;
	}
	function loadBackupAvatar()
	{
		$Pref::Avatar::Accent			= $Backup::Avatar::Accent;
		$Pref::Avatar::AccentColor		= $Backup::Avatar::AccentColor;
		$Pref::Avatar::Chest			= $Backup::Avatar::Chest;
		$Pref::Avatar::ChestColor		= $Backup::Avatar::ChestColor;
		$Pref::Avatar::DecalColor		= $Backup::Avatar::DecalColor;
		$Pref::Avatar::DecalName		= $Backup::Avatar::DecalName;
		$Pref::Avatar::FaceColor		= $Backup::Avatar::FaceColor;
		$Pref::Avatar::FaceName		= $Backup::Avatar::FaceName;
		$Pref::Avatar::Hat			= $Backup::Avatar::Hat;
		$Pref::Avatar::HatColor		= $Backup::Avatar::HatColor;
		$Pref::Avatar::HeadColor		= $Backup::Avatar::HeadColor;
		$Pref::Avatar::Hip			= $Backup::Avatar::Hip;
		$Pref::Avatar::HipColor		= $Backup::Avatar::HipColor;
		$Pref::Avatar::LArm			= $Backup::Avatar::LArm;
		$Pref::Avatar::LArmColor		= $Backup::Avatar::LArmColor;
		$Pref::Avatar::LHand			= $Backup::Avatar::LHand;
		$Pref::Avatar::LHandColor		= $Backup::Avatar::LHandColor;
		$Pref::Avatar::LLeg			= $Backup::Avatar::LLeg;
		$Pref::Avatar::LLegColor		= $Backup::Avatar::LLegColor;
		$Pref::Avatar::Pack			= $Backup::Avatar::Pack;
		$Pref::Avatar::PackColor		= $Backup::Avatar::PackColor;
		$Pref::Avatar::RArm			= $Backup::Avatar::RArm;
		$Pref::Avatar::RArmColor		= $Backup::Avatar::RArmColor;
		$Pref::Avatar::RHand			= $Backup::Avatar::RHand;
		$Pref::Avatar::RHandColor		= $Backup::Avatar::RHandColor;
		$Pref::Avatar::RLeg			= $Backup::Avatar::RLeg;
		$Pref::Avatar::RLegColor		= $Backup::Avatar::RLegColor;
		$Pref::Avatar::SecondPack		= $Backup::Avatar::SecondPack;
		$Pref::Avatar::SecondPackColor	= $Backup::Avatar::SecondPackColor;
		$Pref::Avatar::TorsoColor		= $Backup::Avatar::TorsoColor;
	}
	function loadTeamAvatar(%team,%mode,%face)
	{
		switch(%mode)
		{
			case 0:
				%avi = $Minigame::TDMTeamUniform[%team];
				if(%avi $= "")
				{
					%col = getWords(getColorIDTable(TeamEdit_Colour.value),0,2) SPC 1;
					%avi = 0 TAB %col TAB
					0 TAB %col TAB
					0 TAB %col TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB %col TAB
					0 TAB %col TAB
					1 TAB %col TAB
					1 TAB "0 0.2 0.64 0.7" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.9 0.9 0.0 1" TAB
					"1 0.878 0.611 1" TAB
					"AAA-None" TAB "smileyCreepy";
				}
			case 1:
				%avi = $Minigame::TDMLeadUniform[%team];
				if(%avi $= "")
				{
					%col = getWords(getColorIDTable(TeamEdit_Colour.value),0,2) SPC 1;
					%avi = 0 TAB %col TAB
					0 TAB %col TAB
					0 TAB %col TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB %col TAB
					0 TAB %col TAB
					6 TAB %col TAB
					0 TAB "0 0.2 0.64 0.7" TAB
					0 TAB "1 1 0 1" TAB
					2 TAB "1 1 0 1" TAB
					"1 0.878 0.611 1" TAB
					"AAA-None" TAB "smileyCreepy";
				}
			case 2:
				%avi = $Avatar::HackyBackupAvatar;
				if(%avi $= "")
				{
					%col = getWords(getColorIDTable(TeamEdit_Colour.value),0,2) SPC 1;
					%avi = 0 TAB %col TAB
					0 TAB %col TAB
					0 TAB %col TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB %col TAB
					0 TAB %col TAB
					1 TAB %col TAB
					1 TAB "0 0.2 0.64 0.7" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.9 0.9 0.0 1" TAB
					"1 0.878 0.611 1" TAB
					"AAA-None" TAB "smileyCreepy";
				}
			case 3:
				%avi = $Avatar::HackyBackupAvatar;
				if(%avi $= "")
				{
					%col = getWords(getColorIDTable(TeamEdit_Colour.value),0,2) SPC 1;
					%avi = 0 TAB %col TAB
					0 TAB %col TAB
					0 TAB %col TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB %col TAB
					0 TAB %col TAB
					6 TAB %col TAB
					0 TAB "0 0.2 0.64 0.7" TAB
					0 TAB "1 1 0 1" TAB
					2 TAB "1 1 0 1" TAB
					"1 0.878 0.611 1" TAB
					"AAA-None" TAB "smileyCreepy";
				}
		}
		
		$Avatar::HackyBackupAvatar = %avi;
		
		$Pref::Avatar::Accent			= getField(%avi,18);
		$Pref::Avatar::AccentColor		= getField(%avi,19);
		$Pref::Avatar::Chest			= getField(%avi,0);
		$Pref::Avatar::DecalName		= getField(%avi,25);
		$Pref::Avatar::FaceName		= getField(%avi,26);
		$Pref::Avatar::Hat			= getField(%avi,16);
		$Pref::Avatar::HatColor		= getField(%avi,17);
		$Pref::Avatar::HeadColor		= getField(%avi,24);
		$Pref::Avatar::Hip			= getField(%avi,10);
		$Pref::Avatar::HipColor		= getField(%avi,11);
		$Pref::Avatar::LArm			= getField(%avi,4);
		$Pref::Avatar::LArmColor		= getField(%avi,5);
		$Pref::Avatar::LHand			= getField(%avi,8);
		$Pref::Avatar::LHandColor		= getField(%avi,9);
		$Pref::Avatar::LLeg			= getField(%avi,14);
		$Pref::Avatar::LLegColor		= getField(%avi,15);
		$Pref::Avatar::Pack			= getField(%avi,20);
		$Pref::Avatar::PackColor		= getField(%avi,21);
		$Pref::Avatar::RArm			= getField(%avi,2);
		$Pref::Avatar::RArmColor		= getField(%avi,3);
		$Pref::Avatar::RHand			= getField(%avi,6);
		$Pref::Avatar::RHandColor		= getField(%avi,7);
		$Pref::Avatar::RLeg			= getField(%avi,12);
		$Pref::Avatar::RLegColor		= getField(%avi,13);
		$Pref::Avatar::SecondPack		= getField(%avi,22);
		$Pref::Avatar::SecondPackColor	= getField(%avi,23);
		$Pref::Avatar::TorsoColor		= getField(%avi,1);
		
		for(%i=0;$decal[%i] !$= "";%i++)
		{
			if(fileBase($decal[%i]) $= fileBase($Pref::Avatar::DecalName))
			{
				$pref::Avatar::DecalColor = %i;
				break;
			}
		}
		
		for(%i=0;$face[%i] !$= "";%i++)
		{
			if(fileBase($face[%i]) $= fileBase($Pref::Avatar::FaceName))
			{
				$pref::Avatar::FaceColor = %i;
				break;
			}
		}
		
		//Why is the chest different for this?
		for(%i=0;$minifigColor[%i] !$= "";%i++)
		{
			if($minifigColor[%i] $= $Pref::Avatar::TorsoColor)
			{
				$Pref::Avatar::ChestColor = %i;
				break;
			}
		}
	}
	function saveTeamAvatar(%team,%mode)
	{
		%avi = $Pref::Avatar::Chest TAB fixAvatarColor($Pref::Avatar::TorsoColor,0) TAB
		$Pref::Avatar::RArm TAB fixAvatarColor($Pref::Avatar::RArmColor,0) TAB
		$Pref::Avatar::LArm TAB fixAvatarColor($Pref::Avatar::LArmColor,0) TAB
		$Pref::Avatar::RHand TAB fixAvatarColor($Pref::Avatar::RHandColor,0) TAB
		$Pref::Avatar::LHand TAB fixAvatarColor($Pref::Avatar::LHandColor,0) TAB
		$Pref::Avatar::Hip TAB fixAvatarColor($Pref::Avatar::HipColor,0) TAB
		$Pref::Avatar::RLeg TAB fixAvatarColor($Pref::Avatar::RLegColor,0) TAB
		$Pref::Avatar::LLeg TAB fixAvatarColor($Pref::Avatar::LLegColor,0) TAB
		$Pref::Avatar::Hat TAB fixAvatarColor($Pref::Avatar::HatColor,0) TAB
		$Pref::Avatar::Accent TAB fixAvatarColor($Pref::Avatar::AccentColor,1) TAB
		$Pref::Avatar::Pack TAB fixAvatarColor($Pref::Avatar::PackColor,0) TAB
		$Pref::Avatar::SecondPack TAB fixAvatarColor($Pref::Avatar::SecondPackColor,0) TAB
		$Pref::Avatar::HeadColor TAB
		$Pref::Avatar::DecalName TAB $Pref::Avatar::FaceName;
		
		switch(%mode)
		{
			case 0:
				$Minigame::TDMTeamUniform[%team] = %avi;
			case 1:
				$Minigame::TDMLeadUniform[%team] = %avi;
			case 2:
				$Avatar::HackyBackupAvatar = %avi;
			case 3:
				$Avatar::HackyBackupAvatar = %avi;
		}
	}
	function Avatar_AssignColor(%col)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_AssignColor(%col);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_AssignColor(%col);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_SetFace(%a,%b)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_SetFace(%a,%b);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_SetFace(%a,%b);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_SetDecal(%a,%b)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_SetDecal(%a,%b);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_SetDecal(%a,%b);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_SetHip(%a)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_SetHip(%a);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_SetHip(%a);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_SetChest(%a)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_SetChest(%a);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_SetChest(%a);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_SetPack(%a,%b)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_SetPack(%a,%b);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_SetPack(%a,%b);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_SetSecondPack(%a,%b)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_SetSecondPack(%a,%b);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_SetSecondPack(%a,%b);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_SetHat(%a,%b)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_SetHat(%a,%b);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_SetHat(%a,%b);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_SetAccent(%a,%b)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_SetAccent(%a,%b);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_SetAccent(%a,%b);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_SetRArm(%a)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_SetRArm(%a);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_SetRArm(%a);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_SetLArm(%a)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_SetLArm(%a);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_SetLArm(%a);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_SetRLeg(%a)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_SetRLeg(%a);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_SetRLeg(%a);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_SetLLeg(%a)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_SetLLeg(%a);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_SetLLeg(%a);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_SetRHand(%a)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_SetRHand(%a);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_SetRHand(%a);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_SetLHand(%a)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_SetLHand(%a);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Parent::Avatar_SetLHand(%a);
		AvatarGUI.onWake();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function Avatar_TogglePartMenu(%m)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_TogglePartMenu(%m);
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		Avatar_SetHat($Pref::Avatar::Hat);
		Parent::Avatar_TogglePartMenu(%m);
		loadBackupAvatar();
	}
	function Avatar_Done()
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_Done();
			return;
		}
		
		loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode);
		loadBackupAvatar();
		AvatarGUI.onWake();
		Avatar_Prefix.getGroup().setVisible(1);
		Avatar_Name.getGroup().setVisible(1);
		canvas.popDialog(avatarGUI);
	}
	function AvatarGUI::clickX(%this)
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::clickX(%this);
			return;
		}
		
		Parent::clickX(%this);
		loadBackupAvatar();
	}
	function AvatarGUI::onSleep(%this)
	{
		Parent::onSleep(%this);
		$Avatar::HackyTeamAvatar = 0;
	}
	function Avatar_Randomize()
	{
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::Avatar_Randomize();
			return;
		}
		
		Parent::Avatar_Randomize();
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	function AvatarGui::clickFav(%this,%num)
	{
		//Normal
		if(!$Avatar::HackyTeamAvatar)
		{
			Parent::clickFav(%this,%num);
			return;
		}
		
		//Saving
		if(AV_FavsHelper.isVisible())
		{
			loadTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
			Parent::clickFav(%this,%num);
			loadBackupAvatar();
			return;
		}
		
		//Loading
		Parent::clickFav(%this,%num);
		saveTeamAvatar($SpaceMods::Client::TeamDM::CurrentEditTeam,$Avatar::HackyTeamAvatar_mode+2);
		loadBackupAvatar();
	}
	
	//Game Mode Rules tab
	//Credit for GUI elements code goes mostly to RTB
	function CreateMinigameGUI::setRulesTab(%this)
	{  
		//Clear current GUI
		while(scrModeRules.getCount() > 0)
			scrModeRules.getObject(%i).delete();
		
		%mode = CMG_SelectGamemode.getSelected();
		if((ClientGameModeStorerSO.modeRuleCount[%mode]+ClientGameModeStorerSO.modeRuleCount[-1]) <= 0)
		{
			txtRulesError.setVisible(1);
			scrModeRules.setVisible(0);
			return;
		}
		else
		{
			txtRulesError.setVisible(0);
			scrModeRules.setVisible(1);
		}
		
		txtHelpName.setText(ClientGameModeStorerSO.modeTitle[%mode]);
		txtHelpEnter.setText($Minigame::TDMHelpText);
		chkHelpOnJoin.setValue($Minigame::TDMShowHelp);
		
		%count = ClientGameModeStorerSO.modeRuleCount[%mode] + ClientGameModeStorerSO.modeRuleCount[-1];
		
		for(%i=0;%i<%count;%i++)
		{
			%value = $Minigame::TDMRuleVal[%i];
			
			if(%i >= ClientGameModeStorerSO.modeRuleCount[%mode])
			{
				%str = ClientGameModeStorerSO.modeRuleStr[-1,%i-ClientGameModeStorerSO.modeRuleCount[%mode]];
				%text = ClientGameModeStorerSO.modeRuleTxt[-1,%i-ClientGameModeStorerSO.modeRuleCount[%mode]];
				if(%value $= "")
					%value = ClientGameModeStorerSO.modeRuleDef[-1,%i-ClientGameModeStorerSO.modeRuleCount[%mode]];
			}
			else
			{
				%str = ClientGameModeStorerSO.modeRuleStr[%mode,%i];
				%text = ClientGameModeStorerSO.modeRuleTxt[%mode,%i];
				if(%value $= "")
					%value = ClientGameModeStorerSO.modeRuleDef[%mode,%i];
			}
			
			%swatch = new GuiSwatchCtrl()
			{
				position = "0" SPC %i*30;
				extent = "330 28";
				color = (%k % 2 ? "0 0 0 20" : "0 0 0 10");
				
				new GuiTextCtrl()
				{
					profile = GuiTextProfile;
					position = "5 5";
					extent = "162 18";
					text = %text;
				};
			};scrModeRules.add(%swatch);
			%type = getWord(%str,0);
			switch$(%type)
			{
				case "bool":
					//"bool"
					%var = new GuiCheckboxCtrl()
					{
						position = "170 0";
						extent = "140 30";
						text = "";
						variable = "Minigame::TDMRuleVal" @ %i;
					};
					%swatch.add(%var);
					if(%value)
						%var.setValue(1);
				case "list":
					%var = new GuiPopupMenuCtrl()
					{
						position = "171 4";
						extent = "129 20";
						//variable = "Minigame::TDMRuleVal" @ %i;
					};
					if(strPos(%str,"\t") == -1)
					{
						//Single-word strings only
						//"list" SPC "Red" SPC "0" SPC "Blue" SPC "1" SPC "Green" SPC "2" ...
						for(%j=1;%j<getWordCount(%str);%j+=2)
						{
							%var.add(getWord(%str,%j),getWord(%str,%j+1));
						}
					}
					else
					{
						//Multi-word strings
						//"list" TAB "Red Team" TAB "0" TAB "Blue Team" TAB "1" TAB "Green Team" TAB "2" ...
						for(%j=1;%j<getFieldCount(%str);%j+=2)
						{
							%var.add(getField(%str,%j),getField(%str,%j+1));
						}
					}
					%swatch.add(%var);
					%var.command = "$Minigame::TDMRuleVal" @ %i @ " = " @ %var @ ".getSelected();";
					if(%value !$= "")
						%var.setSelected(%value);
				case "dataBlock":
					%obj = getField(%value,0);
					%name = getField(%value,1);
					%var = new GuiPopupMenuCtrl()
					{
						position = "171 4";
						extent = "129 20";
					};
					if(DatablockGroup.getCount() > 2)
						%group=dataBlockGroup;
					else
						%group=serverConnection;
					%datacount = -1;
					%sel = -1;
					switch$(getWord(%str,1))
					{
						case "Music":
							for(%j=0;%j<%group.getCount();%j++)
							{
								%o = %group.getObject(%j);
								if(%o.getClassName() $= "AudioProfile" && %o.description.isLooping && %o.uiName !$= "")
								{
									%var.add(trim(%o.uiName),%o.getID());
									if((%name $= "" && %obj == %o.getID()) || trim(%o.uiName) $= %name)
										%sel = %o.getID();
								}
							}
						case "Vehicle":
							for(%j=0;%j<%group.getCount();%j++)
							{
								%o = %group.getObject(%j);
								%class = %o.getClassName();
								if(%o.uiName !$= "" && ((%o.rideable && %class $= "PlayerData") || %class $= "WheeledVehicleData" || %class $= "FlyingWheeledVehicleData" || %class $= "FlyingVehicleData"))
								{
									%var.add(%o.uiName,%o.getID());
									if((%name $= "" && %obj == %o.getID()) || %o.uiName $= %name)
										%sel = %o.getID();
								}
							}
						case "Sound":
							for(%j=0;%j<%group.getCount();%j++)
							{
								%o = %group.getObject(%j);
								if(%o.getClassName() $= "AudioProfile" && !%o.description.isLooping)
								{
									%var.add(fileName(%o.fileName),%o.getID());
									if((%name $= "" && %obj == %o.getID()) || fileName(%o.fileName) $= %name)
										%sel = %o.getID();
								}
							}
							default:
							%data=getWord(%str,1);
							for(%j=0;%j<%group.getCount();%j++)
							{
								%o = %group.getObject(%j);
								if(%o.uiName !$= "" && %o.getClassName() $= %data)
								{
									%var.add(%o.uiName,%o.getID());
									if((%name $= "" && %obj == %o.getID()) || %o.uiName $= %name)
										%sel = %o.getID();
								}
							}
					}
					%var.sort();
					%var.addFront("NONE",0);
					//setting %var.variable messes up the contents when the ID and the text are not the same
					%var.command = "$Minigame::TDMRuleVal" @ %i @ " = " @ %var @ "." @ %var @ ".getSelected() TAB " @ %var @ ".getText();";
					%swatch.add(%var);
					if(%sel !$= "")
						%var.setSelected(%sel);
				case "int":
					// "int MIN. MAX."
					%var = new GuiTextEditCtrl()
					{
						position = "171 5";
						extent = "129 18";
						fieldMax = getWord(%str,2);
						fieldMin = getWord(%str,1);
						variable = "Minigame::TDMRuleVal" @ %i;
					};
					%swatch.add(%var);
					%var.setValue(%value);
					%var.command = "TDMClient_CheckForInt("@%var@");";
				case "string":
					// "string MAXLEN."
					%var = new GuiTextEditCtrl()
					{
						position = "171 5";
						extent = "129 18";
						maxLength = getWord(%str,1);
						variable = "Minigame::TDMRuleVal" @ %i;
					};
					%swatch.add(%var);
					%var.setValue(%value);
			}
		}
	}
};activatePackage(MiniGameGUIClient);

//This is quite useful. Fixed according to Trader's suggestions.
function isInt(%string)
{
	return %string $= mFloatLength(%string, 0);
}

//Based off RTBSC_PF_CheckForInt, but allows for negative values (e.g. -10000 to 10000 range)
function TDMClient_CheckForInt(%ctrl)
{
	%value = %ctrl.getValue();
	%start = 0;
	if(getSubStr(%value,0,1) $= "-")
	{
		%start = 1;
		%string = "-";
	}
	for(%i=%start;%i<strLen(%value);%i++)
	{
		if(isInt(getSubStr(%value,%i,1)))
			%string = %string@getSubStr(%value,%i,1);
	}
	
	if(%string $= "")
		%string = 0;
	
	if(%string $= "-")
		%string = -1;
	
	if(%string > %ctrl.fieldMax)
		%string = %ctrl.fieldMax;
	
	if(%string < %ctrl.fieldMin)
		%string = %ctrl.fieldMin;
	
	%ctrl.setValue(%string);
}

//Fixes a colour's values to two decimal places and (optionally) strips alpha value
function fixAvatarColor(%col,%alpha)
{
	if(%alpha)
		return mFloatLength(getWord(%col,0),2) SPC mFloatLength(getWord(%col,1),2) SPC mFloatLength(getWord(%col,2),2) SPC mFloatLength(getWord(%col,3),2);
	else
		return mFloatLength(getWord(%col,0),2) SPC mFloatLength(getWord(%col,1),2) SPC mFloatLength(getWord(%col,2),2) SPC 1;
}
